﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleCorrectness
{
    class Excepts
    {
        Random rnd = new Random();
		int level = -10;
		bool Success; //true - нормальное завершение
		int count =1; // число попыток выполнения
		const int maxcount =3;

        public void Pattern()
        {
            do
            {
                try
                {
                    bool Danger = false;
                    Success = true;
                    MakeJob();
                    Danger = CheckDanger();
                    if (Danger)
                        throw (new MyException());
                    MakeLastJob();
                }
                catch (MyException me)
                {
                    if (count > maxcount)
                        throw (new MyException("Три попытки безуспешны", me));
                      //throw (new MyException("Три попытки были безуспешны"));
                    Success = false; count++;
                    //корректировка ситуации
                    Console.WriteLine("Попытка исправить ситуацию!");
                    level += 1;
                }
            } while (!Success);
        }
        void MakeJob()
        {
            Console.WriteLine("Подготовительные работы завершены");
        }
        bool CheckDanger()
        {
            //проверка качества и возможности продолжения работ
            int low = rnd.Next(level, 10);
            if (low > 6) return (false);
            return (true);
        }
        void MakeLastJob()
        {
            Console.WriteLine("Все работы завершены успешно");
        }
        static public void PrintProperties(Exception e)
        {
            Console.WriteLine("Свойства исключения:");
            Console.WriteLine("TargetSite = {0}", e.TargetSite);
            Console.WriteLine("Source = {0}", e.Source);
            Console.WriteLine("Message = {0}", e.Message);
            if (e.InnerException == null)
                Console.WriteLine("InnerException = null");
            else Console.WriteLine("InnerException = {0}", e.InnerException.Message);
            Console.WriteLine("StackTrace = {0}", e.StackTrace);
            Console.WriteLine("GetBaseException = {0}", e.GetBaseException());
        }

    }
    public class MyException : Exception
    {
        public MyException()
        { }
        public MyException(string message)
            : base(message)
        { }
        public MyException(string message, Exception e)
            : base(message, e)
        { }
    }

}
